
module Mysqlaudit
  class Config
    @configs = nil

    def load(file)
      if !file.nil? && !ENV['ENVIRONMENT'].nil?
        path = File.expand_path(File.join(Dir.pwd, file))

        if File.exist?(path)
          @configs = YAML.load_file(path)
          @configs = @configs[ENV['ENVIRONMENT']]
          @configs = @configs.inject({}){|config,(k,v)| config[k.to_sym] = v; config}
        end
      end
    end

    def merge(options)
      if !@configs.nil?
        options.host   = options.host     || @configs[:host]
        options.user   = options.user     || @configs[:user]
        options.pass   = options.password || @configs[:password]
        options.schema = options.schema   || @configs[:database]
      end

      options
    end
  end
end